﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace prohlizec
{
    public partial class fullscreenform : Form
    {
        private String soubor;
        private float zoom = 1.0f;
        private bool fit = true;
        private int rot;
        private bool hor;
        private bool vert;
        private bool bw;
        public fullscreenform(String s)
        {
            InitializeComponent();
            soubor = s;
            rot = 0;
            hor = false;
            vert = false;
            bw = false;
            this.Focus();
            this.BringToFront();
            this.Activate();
        }

        void fullscreenform_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            // Hura.
            Graphics g = e.Graphics;
            Bitmap img=new Bitmap(soubor);
            
            RotateFlipType rf=RotateFlipType.RotateNoneFlipNone;
            if (rot==1) rf=RotateFlipType.Rotate270FlipNone;
            if (rot==2) rf=RotateFlipType.Rotate180FlipNone;
            if (rot==3) rf=RotateFlipType.Rotate90FlipNone;
            
            img.RotateFlip(rf);

            if (hor)
            {
                rf = RotateFlipType.RotateNoneFlipX;
                img.RotateFlip(rf);
            }
            if (vert)
            {
                rf = RotateFlipType.RotateNoneFlipY;
                img.RotateFlip(rf);
            }

            // A sakra.
            if (bw)
            {
                for (int x = 0; x < img.Width; x++)
                {
                    for (int y = 0; y < img.Height; y++)
                    {
                        Color col = img.GetPixel(x, y);
                        col=Color.FromArgb((byte)(col.GetSaturation()),(byte)(col.GetSaturation()),(byte)(col.GetSaturation()));
                        img.SetPixel(x, y, col);
                    }
                }
            }

            float pomer_stran = (float)img.Width / (float)img.Height;
            
            int thumbx=0,thumby=0;
            if (fit)
            {
                thumbx=(int) ((pomer_stran>1.0f) ? (this.Width) : ((float)this.Height*pomer_stran));
                thumby=(int) ((pomer_stran<1.0f) ? (this.Height) : ((float)this.Width/pomer_stran));
            }
            //int thumbx =(int) ( (thumb.Width > thumb.Height) ? ((float)this.Width) : (64.0f * pomer_stran) );
            //int thumby =(int) ( (thumb.Height > thumb.Width) ? ((float)this.Height) : (64.0f / pomer_stran) );
            
            //g.DrawImage(thumb, new Rectangle((64 - thumbx) / 2, (64 - thumby) / 2, thumbx, thumby));
            //MessageBox.Show("" + thumb.Width + ";" + thumb.Height + "->" + thumbx + ";" + thumby);
            //imageList.Images.Add(realt);
            g.DrawImage(img, new Rectangle(0, 0, thumbx, thumby));
        }

        void fullscreenform_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            //MessageBox.Show("KEYDOWN");
            if (e.KeyCode == Keys.L) rot++;
            if (e.KeyCode == Keys.P) rot--;
            if (e.KeyCode == Keys.H) hor=!hor;
            if (e.KeyCode == Keys.V) vert = !vert;
            if (e.KeyCode == Keys.G) bw = !bw;
            if (e.KeyCode == Keys.Escape) this.Close();
            if (rot == -1) rot = 3; if (rot == 5) rot = 0;
            this.Invalidate();
        }
    }
}
